************************************************************
* Project:	ultraDev
* Module:	UDBitmap
* Code:		ultra
* Created:	23.12.2019
* Notes:	Service routines for the bitmap mode
*			The bitmap mode displays a 128x128 image. 
*			The resolution is halved to fill the screen.
*
*			How does it work?
*			More or less is the bitmap mode very like on vc20
*			You just print the chars from 0 - 255 on screen
*			and the bitmap itself is modified by changing the
*			font.
* Modified:
* Changes:
*
* (c) 2019 cream
************************************************************

UDBitmapInit:
	// switch to double mode
	moveq	#1,d0
	bsr		UDVidSetVideoMode

	// setup screen memory and to fill the screen with chars from 0 - 255
	move	#$700,d6
	moveq	#0,d0
	moveq	#0,d1
	lea		$fb0000,a0

.UDBitmapInitLoop1:
	moveq	#0,d0
	bsr		UDDbgScrSetPosition
	
	move	UDRegWriteToScreen,d3

	move	#$0,d7
.UDBitmapInitLoop2:
	move	d6,d0
	add		d0,d0
	move	(a0,d0),d3

	add.b	#1,d6
	addq	#1,d7
	cmp		#16,d7
	bne.s	.UDBitmapInitLoop2
	addq	#1,d1
	cmp		#16,d1
	bne		.UDBitmapInitLoop1
	rts

************************************************************
UDBitmapUploadBitmap:
; uploads a bitmap
; what is the difference to UDFontUpload?
; the bitmap mode is char based. means the graphic format
; is like the c64 char based. 
; this routine uploads a bitmap line based
; the routine expects an image of 128x128 means 2kb
;
; ->a0 bitmap to upload

	lea		$fb0000,a0
	move	UDRegWriteToFontAdrIncr,d2	; set font increment to 8
	move	16(a0),d1

	moveq	#0,d7
.UDBitmapLoop:
	move	UDRegWriteToFontAdr,d2	; set font destination address
	move	d7,d1
	and		#$7,d1					; calc font adress
	move	d7,d2
	lsr		#3,d2
	lsl		#7,d2
	add		d2,d1
	add		d1,d1
	move	(a0,d1),d1

	move	UDRegWriteToFontMemory,d2
	move	#15,d0
.UDBitmapLineLoop:
	moveq	#0,d1
	move.b	(a1)+,d1			
	add		d1,d1
	move	(a0,d1),d1
	dbf		d0,.UDBitmapLineLoop

	addq	#1,d7
	cmp		#128,d7
	bne.s	.UDBitmapLoop
	rts
